146	OpenVPN Alternate Method of Authentication	openvpn-alternate-method-of-authentication		I have written an article <span style="font-weight: bold;">OpenVPN over Virtual Private Server (VPS)</span>, where only method of authentication is through certificates. In this method you can use username/password authentication method along with certificates.<br /><br />Before reading this howto please read my previous how to install OpenVPN. You can find it in following two locations<br /><br /><span style="font-weight: bold;">1. http://www.wbitt.com/contributed-howtos/145-openvpn-over-virtual-private-server-vps.html</span><br /><span style="font-weight: bold;">2. http://saifurab.blogspot.com/2009/12/openvpn-over-virtual-private-server-vps.html</span><br /><br /><br />To use this authentication method, first add the <span style="font-weight: bold;">auth-user-pass</span> directive to the client configuration file. You will not find this directive in conf file so u just need to add it bottom of the file. It will direct the OpenVPN client to query the user for a username/password, passing it on to the server over the secure TLS channel.<br /><br />Next, configure the server to use an authentication plug-in, which may be a script, shared object, or DLL. The OpenVPN server will call the plug-in every time a VPN client tries to connect, passing it the username/password entered on the client.<br /><br />I used <span style="font-weight: bold;">Script</span> for authentication.<br /><br />Script plug-in can be used by adding the auth-user-pass-verify directive to the server-side configuration file. You need to run your openVPN server as below<br /><br /><span style="font-weight: bold;"># cd /etc/openvpn</span><br /><span style="font-weight: bold;"># cp /root/openvpn-2.1_rc20/sample-scripts/auth-pam.pl /etc/openvpn/</span><br /><span style="font-weight: bold;"># openvpn --config server.conf --auth-user-pass-verify auth-pam.pl via-file --script-security 2</span><br /><br /><span style="font-weight: bold;">auth-pam.pl </span>perl script is used to authenticate the username/password of connecting clients. The auth-pam.pl script is included in the OpenVPN source file distribution in the<span style="font-weight: bold;"> sample-scripts </span>subdirectory. It will authenticate users on a Linux server using a PAM authentication module, which could in turn implement shadow password. Ideally, copy auth-pam.pl in /etc/openvpn folder.<br /><br /><span style="font-style: italic;">When I started the server it started successfully but I got the error. i.e Can't locate Authen/PAM.pm</span><br /><br /><span style="font-style: italic;">For this I did following</span><br /><br /><span style="font-weight: bold;"># wget http://www.perl.com/CPAN/authors/id/N/NI/NIKIP/Authen-PAM-0.16.tar.gz</span><br /><span style="font-weight: bold;"># tar xvzf Authen-PAM-0.16.tar.gz</span><br /><span style="font-weight: bold;"># cd Authen-PAM-0.16</span><br /><span style="font-weight: bold;"># perl Makefile.PL</span><br /><span style="font-weight: bold;"># make &amp;&amp; make install</span><br /><span style="font-weight: bold;"># perl -e 'use Authen::PAM; print "Installation succestul.\\n"'</span><br /><br />Now create an ordinary user<br /><br /><span style="font-weight: bold;"># useradd saif</span><br /><span style="font-weight: bold;"># passwd saif</span><br /><br />And use this username to login on client side.<br /><br /><br />You can also add <span style="font-weight: bold;">--client-cert-not-required</span> directive while starting the openVPN server. In this case you don't require client certificate, client will authenticate using username/password only but using this directive is less secure than requiring certificates from all clients.		1	11	0	34	2009-12-15 08:09:15	70	Saif ur Rab	2010-12-27 06:17:31	63	0	0000-00-00 00:00:00	2009-12-15 08:07:42	0000-00-00 00:00:00			show_title=\
link_titles=\
show_intro=\
show_section=\
link_section=\
show_category=\
link_category=\
show_vote=\
show_author=\
show_create_date=\
show_modify_date=\
show_pdf_icon=\
show_print_icon=\
show_email_icon=\
language=\
keyref=\
readmore=	3	0	16	openVPN authentication		0	9112	robots=\
author=
